"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const Config_1 = __importDefault(require("@components/Config"));
const Loading_1 = __importDefault(require("../Loading"));
const Toast_1 = __importDefault(require("../Toast"));
const storage_1 = require("../Fn/storage");
const react_native_device_info_1 = require("react-native-device-info");
const Fetch = (url, params = {}, extend = {}) => __awaiter(void 0, void 0, void 0, function* () {
    const opts = {
        url,
        method: (extend && (extend === null || extend === void 0 ? void 0 : extend.method)) || 'post',
        baseURL: '',
        headers: Object.assign({ 'content-type': 'application/x-www-form-urlencoded', 'uuid': (0, react_native_device_info_1.getUniqueId)() }, extend.headers),
        timeout: 30000,
        withCredentials: true,
        responseType: 'json',
        responseEncoding: 'utf8',
        maxContentLength: 2000,
    };
    const $token = yield (0, storage_1.$getStorage)('$$token');
    if ($token === null || $token === void 0 ? void 0 : $token.accessToken) {
        opts.headers = Object.assign(Object.assign({}, opts.headers), { accessToken: $token.accessToken });
    }
    if (!/http/.test(url)) {
        if ((extend === null || extend === void 0 ? void 0 : extend.apiType) === 'common') {
            opts.baseURL = Config_1.default.apiCommon;
        }
        else {
            switch (Config_1.default.appType) {
                case 'SHOP':
                    opts.baseURL = Config_1.default.apiShop;
                    break;
                case 'RIDER':
                    opts.baseURL = Config_1.default.apiRider;
                    break;
                default:
                    opts.baseURL = Config_1.default.apiHost;
            }
        }
    }
    else {
        opts.baseURL = '';
    }
    if ((extend === null || extend === void 0 ? void 0 : extend.post) === true) {
        opts.data = Object.assign({}, params);
        opts.headers = Object.assign(Object.assign(Object.assign({}, opts.headers), { 'content-type': 'application/json' }), (extend.headers || {}));
    }
    else {
        opts.params = Object.assign({}, params);
    }
    const ext = {
        loading: (extend && extend.loading === false) ? false : true,
        toast: (extend && extend.toast === false) ? false : true,
    };
    (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.show();
    return new Promise((resolve, reject) => {
        (0, axios_1.default)(opts).then(res => {
            var _a;
            console.log(`res___________${opts.baseURL + opts.url}\n`);
            (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.hide();
            if (res && res.data && res.data.success) {
                console.log('res__________success_true');
                resolve(res.data.result);
            }
            else {
                console.log('res__________success_false', res);
                if (ext === null || ext === void 0 ? void 0 : ext.toast)
                    Toast_1.default.show(((_a = res === null || res === void 0 ? void 0 : res.data) === null || _a === void 0 ? void 0 : _a.message) || '网络繁忙，请稍后再试！');
                reject((res === null || res === void 0 ? void 0 : res.data) || res);
            }
        }).catch((err) => {
            (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.hide();
            console.log(`err___________${opts.baseURL + opts.url}\n`);
            if (ext === null || ext === void 0 ? void 0 : ext.toast)
                Toast_1.default.show((err === null || err === void 0 ? void 0 : err.message) || '网络繁忙，请稍后再试！');
            reject(err);
        });
    });
});
exports.default = Fetch;
